//
//  TokenFieldController.m
//  NSTokenField
//
//  Created by Tom Bunch on Mon3/10/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "TokenFieldController.h"

#import <OmniFoundation/OmniFoundation.h>

#import "Token.h"

static BOOL (*original_insertNewline)(id self, SEL _cmd, id sender);

@interface NSTokenTextView: NSTextView
{
}
@end

@interface NSTokenTextView (Private)
- (void)insertNewline:(id)sender;
@end

@implementation NSTokenTextView (OPFixes)
+ (void)performPosing;
{
    original_insertNewline = (typeof(original_insertNewline))OBReplaceMethodImplementationWithSelector(self, @selector(insertNewline:), @selector(replacement_insertNewline:));
}

- (void)replacement_insertNewline:(id)sender;
{
    [self insertTab:sender];
    original_insertNewline(self, _cmd, sender);
}

@end


@implementation TokenFieldController

- (void)awakeFromNib;
{
    NSArray *objectValue = [NSArray arrayWithObjects:[[Token alloc] initWithTokenString:@"Token 1"], [[Token alloc] initWithTokenString:@"Token 2"], nil];
    [tokenField setObjectValue:objectValue];
}

- (IBAction)logValue:(id)sender;
{
    NSLog(@"token field objectValue  = %@", [sender objectValue]);
}

- (id)tokenField:(NSTokenField *)_tokenField representedObjectForEditingString: (NSString *)editingString;
{
    if ([editingString containsString:[NSString stringWithCharacter:0x1361]]) {
	editingString = [editingString stringByReplacingAllOccurrencesOfString:[NSString stringWithCharacter:0x1361] withString:@" "];
	return [[Token alloc] initWithTokenString:editingString];
    }
    
    NSLog(@"[%@ %s%@]", self, _cmd, editingString);
    return editingString;
}

- (NSString *)tokenField:(NSTokenField *)tokenField displayStringForRepresentedObject:(id)representedObject;
{
    if ([representedObject isKindOfClass:[Token class]]) 
	return [(Token*)representedObject tokenString];

    return representedObject;
}

- (NSTokenStyle)tokenField:(NSTokenField *)tokenField styleForRepresentedObject:(id)representedObject;
{
    if ([representedObject isKindOfClass:[Token class]]) {
#if 0
	// This is a test... if you enable this code, put a single space between the two setup tokens, tab out, in, out, the space vanishes.  You have to use NSDefaultTokenStyle for your token to be preserved.
	if ([[(Token*)representedObject tokenString] isEqualToString:@" "])
	    return NSPlainTextTokenStyle;
	else
#endif
	return NSDefaultTokenStyle;
    } else
	return NSPlainTextTokenStyle;
}

- (BOOL)control:(NSControl *)control isValidObject:(id)object
{
    [object replaceAllOccurrencesOfCharactersInSet:[NSCharacterSet whitespaceCharacterSet] withString:[NSString stringWithCharacter:0x1361]];
    return YES;
}

@end